<app-loading *ngIf="isLoading"></app-loading>
<div class="app-card">
  <div class="container-fluid" nz-col nzSpan="24" *ngIf="isUpdate">
    <div class="form">
      <div nz-row class="form-row">
        <div nz-col nzSpan="6" class="form-row__left">
          <button nz-button nzType="primary" class="button-header" [ngClass]="!isList ? '' : 'active'"
            (click)="chooseTab()">{{'system.role.label.attributes.information' | translate}}</button>
          <button nz-button nzType="primary" class="button-header" [ngClass]="isList ? '' : 'active'"
            (click)="chooseTab()">{{'system.role.label.attributes.usersOfRole' | translate}}</button>
        </div>
      </div>
    </div>
  </div>
  <form nz-form [formGroup]="form" *ngIf="!isList || !isUpdate">
    <div class="app-row" nz-row [nzGutter]="[30, 0]">
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="code"
          [mbType]="isSubmitted && form.controls['code'].errors ? 'error' : 'default'" [mbDisable]="isUpdate"
          (mbBlur)="codeBlur()" [mbMaxLength]="50" uppercase
          [mbShowError]="isSubmitted && form.controls['code'].errors !== null" [mbErrors]="form.controls['code'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '50' }},
           { errorName: 'code', errorDescription: 'system.validate.code' | translate },
           { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.role.label.attributes.code' | translate }}]"
          mbPlaceholderText="--{{'system.role.label.attributes.code' | translate}}--"
          mbLabelText="{{'system.role.label.attributes.code' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
        <span class="warning">{{'system.warning.prefixHCM' | translate}}</span>
      </div>
      <div nz-col nzXs="24" nzLg="12">
        <mb-input-text formControlName="name"
          [mbType]="isSubmitted && form.controls['name'].errors ? 'error' : 'default'" [mbMaxLength]="150"
          [mbShowError]="isSubmitted && form.controls['name'].errors !== null" [mbErrors]="form.controls['name'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '150' }},
                          { errorName: 'required', errorDescription: 'system.validate.required' | translate: {'param': 'system.role.label.attributes.name' | translate }}]"
          mbPlaceholderText="--{{'system.role.label.attributes.name' | translate}}--"
          mbLabelText="{{'system.role.label.attributes.name' | translate}} <span class='label__required'>*</span>">
        </mb-input-text>
      </div>
      <div nz-col nzXs="24" nzLg="24">
        <mb-input-text formControlName="description" [mbIsTextAre]='true' [mbConfig]="{ rows: 3, autoSize: true }"
          [mbMaxLength]="150" [mbType]="isSubmitted && form.controls['description'].errors ? 'error' : 'default'"
          [mbShowError]="isSubmitted && form.controls['description'].errors !== null"
          [mbErrors]="form.controls['description'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'system.validate.maxLength' | translate: {'numberLength': '150' }}]"
          mbPlaceholderText="--{{'system.role.label.attributes.description' | translate}}--"
          mbLabelText="{{'system.role.label.attributes.description' | translate}}"></mb-input-text>
      </div>
    </div>
    <div class="footer" *ngIf="!isList">
      <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="save()" mbType='SUBMIT'
                 mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.save' | translate}}"></mb-button>
    </div>
  </form>
  <div *ngIf="isList && isUpdate">
    <div class="container-search" nz-col nzSpan="24">
      <div class="form">
        <div nz-row class="form-row">
          <div nz-col nzSm='12' nzLg='7' class="form-row__left">
            <input nz-input class="form-row__input" placeholder="{{'common.label.search' | translate}}"
              [(ngModel)]="textFilter" trim (keyup.enter)="search()" />
            <mb-button class="rc-bt-center" mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="search()"
              mbButtonAvailableStyle="PRIMARY" mbPrefixIcon="search"
              nzTooltipTitle="{{'common.label.search' | translate}}" nzTooltipPlacement="bottom" nz-tooltip></mb-button>
          </div>
        </div>
      </div>
    </div>
    <div class="data-table" oncontextmenu="return false;">
      <nz-table #basicTable [nzData]="listUser" [nzShowPagination]="false" nzSize='small'
        [nzScroll]="listUser.length > 7 ? { y: '400px' } : {}" [nzPageSize]="limit">
        <thead>
          <tr class="table-header">
            <th scope="col" class="text-nowrap text-center" nzWidth='50px' nzLeft='0'></th>
            <th scope="col" class="text-nowrap text-center" nzWidth='80px' nzLeft='50px'>{{'system.table.stt' | translate}}</th>
            <th scope="col" class="text-nowrap">{{'system.role.label.table.userName' | translate}}</th>
            <th scope="col" class="text-nowrap">{{'system.role.label.table.fullName' | translate}}</th>
            <th scope="col" class="text-nowrap">{{'system.role.label.table.email' | translate}}</th>
            <th scope="col" class="text-nowrap text-center">{{'system.role.label.table.employeeCode' | translate}}</th>
          </tr>
        </thead>
        <tbody>
          <tr class="row-table" *ngFor="let data of basicTable.data ;let i = index; trackBy: trackByFn">
            <td nzWidth='50px' nzLeft='0' class="text-center">
              <label nz-checkbox [nzChecked]="isChecked(data.isUserInRole)" (nzCheckedChange)="onCheckboxFn(data, $event)"> </label>
            <td nzWidth='80px' nzLeft='50px' class="text-center">{{validateService.getRowIndex(i, pageable?.currentPage, basicTable.nzPageSize)}}
            </td>
            <td>{{ data.username }}</td>
            <td>{{ data.fullName }}</td>
            <td>{{ data.email }}</td>
            <td class="text-center"> {{ data.empCode }}</td>
          </tr>
        </tbody>
      </nz-table>
      <div class="pagination" *ngIf="listUser && listUser.length > 0">
        <div class="pagination__table-info">
          <img alt="idea.svg" class="pagination__table-info--icon" src="assets/images/icon/idea.svg" />
          <span class="pagination__table-info--text">Tìm thấy {{ pageable?.totalElements }} kết quả, hiển thị từ
            {{ pageable.size * (pageable.currentPage - 1) + 1 }} đến
            {{ pageable.size * (pageable.currentPage - 1) + + listUser.length }}</span>
        </div>
        <nz-pagination [(nzPageIndex)]="pageable && pageable.currentPage" [nzTotal]="pageable?.totalElements"
          [nzPageSize]="pageable?.size" (nzPageIndexChange)="search($event)" class="pagination__icon">
        </nz-pagination>
      </div>
    </div>
  </div>
</div>
